//=============================================================================
// ComboShock by Back4More 2013
// Thanks to ILoveUT99 + FeraliDragon + Creator of UTToolbox for code snipets
//=============================================================================

//class ComboShock expands Mutator config(ComboShock);
class ComboShock extends Damage config(ComboShock);

var config name WeaponName, AmmoName;
var config string WeaponString, AmmoString;
var config float InitialAmmo;
var config bool bUseCustomInitialAmmo;
var config bool bGiveShockRifle;
var config string ShockRifleClass;
var config bool bKeepInventoryDM;
var config bool bKeepInventoryCTF;
var config bool bKeepInventoryAS;
var config bool bKeepInventoryDOM;
var config bool bKeepInventoryTDM;
var config bool bKeepInventoryLMS;
var config bool bKeepInventoryOther;
var bool bKeepInv;
//var config bool bKeepInventoryOther;

// Damage Control
//var config name WeaponName[2];
//var config float WeaponDamageScaling[2];
//var config float WeaponKnockbackScaling[2];

// Only allow This Arena
/*function AddMutator(Mutator M)
{
    if ( M.IsA('Arena') )
    {
        log(M$" not allowed (already have an Arena mutator)");
        return; //only allow one arena mutator
    }
    Super.AddMutator(M);
}*/

//remove everything...
function PostBeginPlay()
{
	local actor Other;
	
	
	// Get rid of all pickups
	foreach AllActors( class 'Actor', Other )
	{
		if( !Other.IsA('UT_Jumpboots') &&
		( Other.IsA('Pickup')
		|| Other.IsA('Pickupbase')
		|| Other.IsA('Weapon')
		|| Other.IsA('Ammo') )
		)
		{
			if( Inventory(Other).MyMarker != None)
			{
				//log(Other@"has been destroyed");
				Other.Destroy();
				
			}
		}
    	}
	
	Super.PostBeginPlay();
	/*Log("#==========================================#");    // Write our log message*/
	Log("# ComboShock Mutator Loaded Successfully  #");    // Write our log message
	Log("# Made by Back4More *NewNet Version* v1.0 #");
	Log("#=========================================#");    // Write our log message
	// check for gametype
	If ((Level.Game.IsA('Assault')) && bKeepInventoryAS)
	{
	bKeepInv=true;
	Log("# ComboShock - Inventory Enabled for Assault GameType");
	Log("# bKeepInv="$bKeepInv);
	return;
	}
	else If ((Level.Game.IsA('DeathMatchPlus')) && bKeepInventoryDM) 
	{
	bKeepInv=true;
	Log("# ComboShock - Inventory Enabled for DeathMatchPlus GameType");
	Log("# bKeepInv="$bKeepInv);
	return;
	}
	else If ((Level.Game.IsA('TeamGamePlus')) && bKeepInventoryTDM) 
	{
	bKeepInv=true;
	Log("# ComboShock - Inventory Enabled for TeamGamePlus GameType");
	Log("# bKeepInv="$bKeepInv);
	return;
	}
	else If ((Level.Game.IsA('CTFGame')) && bKeepInventoryCTF)
	{
	bKeepInv=true;
	Log("# ComboShock - Inventory Enabled for CTFGame GameType");
	Log("# bKeepInv="$bKeepInv);
	return;
	}
	else If ((Level.Game.IsA('Domination')) && bKeepInventoryDOM)
	{
	bKeepInv=true;
	Log("# ComboShock - Inventory Enabled for Domination GameType");
	Log("# bKeepInv="$bKeepInv);
	return;
	}
	else If ((Level.Game.IsA('LastManStanding')) && bKeepInventoryLMS) 
	{
	bKeepInv=true;
	Log("# ComboShock - Inventory Enabled for LastManStanding GameType");
	Log("# bKeepInv="$bKeepInv);
	return;
	}
	else if (bKeepInventoryOther == true)
	{
	bKeepInv=true;
	Log("# ComboShock - Inventory Enabled for Other GameType");
	Log("# bKeepInv="$bKeepInv);
	return;
	}
	else
	{
	bKeepInv=false;
	return;
	}
	// end check for gametype..
	Log("## bKeepInv="$bKeepInv);
	
}



function bool AlwaysKeep(Actor Other)
{
    local bool bTemp;

    if ( Other.IsA(WeaponName) )
    {
        Weapon(Other).PickupAmmoCount = Weapon(Other).AmmoName.Default.MaxAmmo * initialAmmo;
        return true;
    }
    if ( Other.IsA(AmmoName) )
    {
        Ammo(Other).AmmoAmount = Ammo(Other).MaxAmmo * InitialAmmo;
        return true;
    }
	// inserted
	if ( Other.Owner == self)
    {    
		return true;
	return super.AlwaysKeep(Other);
	}	
	// end
    

    if ( NextMutator != None )
        return ( NextMutator.AlwaysKeep(Other) );
    return false;
}
// inserted

//give weapon
function ModifyPlayer(Pawn Other)
{
	if (bgiveShockRifle      ) GiveWeapon(Other, ShockRifleClass);
	
	//Log("ComboShock bKeepInv State="$bKeepInv);
	
	super.ModifyPlayer(Other);
	if (NextMutator != None)
      NextMutator.ModifyPlayer(Other);
}

// inserted
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	
    if ( Other.IsA('Weapon') )
    {
       
        if ((WeaponString != "") && !Other.IsA(WeaponName))
        {
            Level.Game.bCoopWeaponMode = false;
            ReplaceWith(Other, WeaponString);
            return false;
			
        }
    }

    if ( Other.IsA('Ammo') )
    {
        
        if ((AmmoString != "") && !Other.IsA(AmmoName))
        {
            ReplaceWith(Other, AmmoString);
            return false;
        }
    }
		
    bSuperRelevant = 0;
    return true;
}

//BGiveWeapon Function
function GiveWeapon(Pawn P, String WeaponName)
{
    local class<Weapon> WeaponClass;
    local Weapon W;

    WeaponClass = class<Weapon>(DynamicLoadObject(WeaponName, class'Class'));
    if (WeaponClass == None)
        return;

    if (P.FindInventoryType(WeaponClass) != None)
        return;

    W = P.Spawn(WeaponClass, self);
    if (W != None)
    {
        W.RespawnTime = 0.0;
        W.GiveTo(P);
        W.bHeldItem = true;
        W.bCanThrow = false;
        if (W.AmmoName != None)
        {
            if (bUseCustomInitialAmmo)
            {
                W.PickupAmmoCount = W.AmmoName.default.MaxAmmo * InitialAmmo;
                if (W.PickupAmmoCount <= 0)
                    W.PickupAmmoCount = 1;
            }
            W.GiveAmmo(P);
        }
        W.SetSwitchPriority(P);
        W.WeaponSet(P);
        W.AmbientGlow = 0;
        if (P.IsA('PlayerPawn'))
            W.SetHand(PlayerPawn(P).Handedness);
        else
            W.GotoState('Idle');
    }
}

//...
function Class<Weapon> MutatedDefaultWeapon()
{
    return None;
}

defaultproperties
{
	WepName(1)=NoSpamShockRifle
    WeaponName=NoSpamShockRifle
    AmmoName=ShockCore
    WeaponString="ComboShockv1c.NoSpamShockRifle"
    AmmoString="Botpack.ShockCore"
    InitialAmmo=999.00
    bGiveShockRifle=True
    ShockRifleClass="ComboShockv1c.NoSpamShockRifle"
    bKeepInventoryCTF=True
    bKeepInventoryAS=True
    bKeepInventoryDOM=True
    DefaultWeapon=Class'NoSpamShockRifle'
}
