/* -*- coding:utf-8 -*- */

class Damage extends Mutator
    config(ComboShock);


var config float DamageScaling;
var config float KnockbackScaling;
var config float SelfDamageScaling;
var config float SelfKnockbackScaling;
var config float FallDamageScaling;
var config float ZoneDamageScaling;
var config name WepName[16];
var config float WeaponDamageScaling[16];
var config float WeaponKnockbackScaling[16];

function PostBeginPlay()
{
    super.PostBeginPlay();
    Level.Game.RegisterDamageMutator(self);
	Log("#=========================================#");    // Write our log message
	Log("# 	ComboShock Properties Settings	     #");    // Write our log message
	Log("#=========================================#");    // Write our log message
	Log("#	DamageScaling:		"$DamageScaling$"     #"); //test
	Log("#	KnockbackScaling:	"$KnockbackScaling$"     #");
	Log("#	SelfDamageScaling:	"$SelfDamageScaling$"     #");
	Log("#   	SelfKnockbackScaling:	"$SelfKnockbackScaling$"     #");
	Log("#	FallDamageScaling:	"$FallDamageScaling$"     #");
	Log("#	ZoneDamageScaling:	"$ZoneDamageScaling$"     #");
	Log("#=========================================#");
}


function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
    if (Other.IsA('ZoneInfo'))
        ZoneInfo(Other).DamagePerSec *= ZoneDamageScaling;

    return true;
}

function MutatorTakeDamage(
        out int ActualDamage,
        Pawn Victim,
        Pawn InstigatedBy,
        out Vector HitLocation,
        out Vector Momentum,
        name DamageType)
{
    local Weapon W;
    local int i;

    if (Victim == InstigatedBy)
    {
        ActualDamage *= SelfDamageScaling;
        Momentum *= SelfKnockbackScaling;
    }
    else
    {
        ActualDamage *= DamageScaling;
        Momentum *= KnockbackScaling;
    }

    if (InstigatedBy != None && InstigatedBy.Weapon != None)
    {
        W = InstigatedBy.Weapon;
        for (i = 0; i < ArrayCount(WepName); ++i)
        {
            if (W.IsA(WepName[i]))
            {
                ActualDamage *= WeaponDamageScaling[i];
                Momentum *= WeaponKnockbackScaling[i];
                break;
            }
        }
    }

    if (DamageType == 'Fall')
        ActualDamage *= FallDamageScaling;

    super.MutatorTakeDamage(
            ActualDamage,
            Victim,
            InstigatedBy,
            HitLocation,
            Momentum,
            DamageType);
}
/* vim:set tw=78 ts=8 sts=4 sw=4 et: */



defaultproperties
{
    DamageScaling=1.00
    KnockbackScaling=1.00
    SelfDamageScaling=1.00
    SelfKnockbackScaling=1.00
    FallDamageScaling=1.00
    ZoneDamageScaling=1.00
    WepName=ShockRifle
    WeaponDamageScaling(0)=1.00
    WeaponDamageScaling(1)=1.00
    WeaponDamageScaling(2)=1.00
    WeaponDamageScaling(3)=1.00
    WeaponDamageScaling(4)=1.00
    WeaponDamageScaling(5)=1.00
    WeaponDamageScaling(6)=1.00
    WeaponDamageScaling(7)=1.00
    WeaponDamageScaling(8)=1.00
    WeaponDamageScaling(9)=1.00
    WeaponDamageScaling(10)=1.00
    WeaponDamageScaling(11)=1.00
    WeaponDamageScaling(12)=1.00
    WeaponDamageScaling(13)=1.00
    WeaponDamageScaling(14)=1.00
    WeaponDamageScaling(15)=1.00
    WeaponKnockbackScaling(0)=1.00
    WeaponKnockbackScaling(1)=1.00
    WeaponKnockbackScaling(2)=1.00
    WeaponKnockbackScaling(3)=1.00
    WeaponKnockbackScaling(4)=1.00
    WeaponKnockbackScaling(5)=1.00
    WeaponKnockbackScaling(6)=1.00
    WeaponKnockbackScaling(7)=1.00
    WeaponKnockbackScaling(8)=1.00
    WeaponKnockbackScaling(9)=1.00
    WeaponKnockbackScaling(10)=1.00
    WeaponKnockbackScaling(11)=1.00
    WeaponKnockbackScaling(12)=1.00
    WeaponKnockbackScaling(13)=1.00
    WeaponKnockbackScaling(14)=1.00
    WeaponKnockbackScaling(15)=1.00
}
