class NoSpamShockRifle expands ShockRifle config(ComboShock);

var() config bool enableNoSpam;
var() config int MaxShockBalls;


function AltFire( float Value )
{
local actor HitActor;
local vector HitLocation, HitNormal, Start;

	if (Owner == None)
		return;

	if (Owner.IsA('Bot')) //make sure won't blow self up
	{
		Start = Owner.Location + CalcDrawOffset() + FireOffset.Z * vect(0,0,1); 
		if (Pawn(Owner).Enemy != None)
			HitActor = Trace(HitLocation, HitNormal, Start + 250 * Normal(Pawn(Owner).Enemy.Location - Start), Start, false, vect(12,12,12));
		else
			HitActor = self;
		if (HitActor != None)
		{
			Global.Fire(Value);
			return;
		}
	}  

	if (AmmoType.UseAmmo(1))
	{
		GotoState('AltFiring');
		bCanClientFire = true;
		if (Owner.IsA('Bot'))
		{
			if ( Owner.IsInState('TacticalMove') && (Owner.Target == Pawn(Owner).Enemy)
			 && (Owner.Physics == PHYS_Walking) && !Bot(Owner).bNovice
			 && (FRand() * 6 < Pawn(Owner).Skill))
				Pawn(Owner).SpecialFire();
		}
		Pawn(Owner).PlayRecoil(FiringSpeed);
		bPointing=True;
		
		if (canFireAltProjectile())
			ProjectileFire(AltProjectileClass, AltProjectileSpeed, bAltWarnTarget);
		ClientAltFire(value);
	}
}

function bool canFireAltProjectile()
{
local int shockBalls;
local Projectile lproj;

	if (!enableNoSpam || MaxShockBalls <= 0)
		return True;
		
	ForEach AllActors(Class'Projectile', lproj)
	{
		if (lproj.Class == AltProjectileClass && lproj.Instigator == Pawn(Owner))
			shockBalls++;
	}
	return (shockBalls < MaxShockBalls);
}

function float RateSelf( out int bUseAltMode )
{
local Pawn P;
local bool bNovice;

    if ( AmmoType.AmmoAmount <=0 )
        return -2;

    P = Pawn(Owner);
    bNovice = ( (Bot(Owner) == None) || Bot(Owner).bNovice );
    if ( P.Enemy == None )
        bUseAltMode = 0;
    else if ( P.Enemy.IsA('StationaryPawn') )
    {
        bUseAltMode = Int(canFireAltProjectile());
        return (AIRating + 0.4);
    }
    else if ( !bNovice && (P.IsInState('Hunting') || P.IsInState('StakeOut')
        || P.IsInState('RangedAttack')
        || (Level.TimeSeconds - P.LastSeenTime > 0.8)) )
    {
		
        bUseAltMode = Int(canFireAltProjectile());
        return (AIRating + 0.3);
    }
    else if ( !bNovice && (P.Acceleration == vect(0,0,0)) )
        bUseAltMode = Int(canFireAltProjectile());
    else if ( !bNovice && (VSize(P.Enemy.Location - P.Location) > 1200) )
    {
        bUseAltMode = 0;
        return (AIRating + 0.05 + FMin(0.00009 * VSize(P.Enemy.Location - P.Location), 0.3)); 
    }
    else if ( P.Enemy.Location.Z > P.Location.Z + 200 )
    {
        bUseAltMode = int( FRand() < 0.6 * Int(canFireAltProjectile()));
        return (AIRating + 0.15);
    } 
    else
        bUseAltMode = int( FRand() < 0.4 * Int(canFireAltProjectile()));

    return AIRating;
}


defaultproperties
{
	enableNoSpam=True
	MaxShockBalls=3
}

